// Medusa is a graph viewer which allows interactive editing of networks
// (edges and nodes) and also connects to databases.
//
// Copyright (C) 2006 Sean Hooper
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or (at 
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
// Public License for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA
package medusa;

import java.awt.*;
import javax.swing.*;
class LegendSwatch implements Icon { 
    Color c;
   

    public LegendSwatch(Color c) { 
	this.c=c;
    } 
    
    public int getIconWidth() { 
	return 11; 
    } 
    
    public int getIconHeight() { 
	return 11; 
    } 
    
    public void paintTriangle(Graphics2D g, int x, int y){
	int[]xPoints={x,x+getIconWidth(),x};
	int[]yPoints={y, y+getIconHeight(), y+getIconHeight()};
	int nPoints=3;
	//g2d.setPaint(c);
	g.fillPolygon(xPoints,yPoints,nPoints);
    }

    public void paintIcon(Component comp, Graphics g, int x, int y) { 
	Graphics2D g2d=(Graphics2D) g;
	g2d.setStroke(new BasicStroke(2));
	g2d.setPaint(c); 
	//g2d.drawLine(x,y,x+getIconWidth(),y+getIconHeight());
	paintTriangle(g2d,x,y);
	
    } 
} 
