// Medusa is a graph viewer which allows interactive editing of networks
// (edges and nodes) and also connects to databases.
//
// Copyright (C) 2006 Sean Hooper
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or (at 
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
// Public License for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA

/*
 * MedusaDataConnection.java
 *
 * Created on October 4, 2006, 11:48 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package medusa;

import java.awt.Component;
import medusa.graph.Graph;
import medusa.graph.Node;

/**
 * Interface for all generic data connections. 
 * If you want to write your own data connections, all you need to 
 * do is to implement the <CODE>getGraph()</CODE> method.
 * @author hooper
 */
public interface MedusaDataConnection {
    
    
    /**
     * This is all you need. Medusa will just ask the connection
     * for the resulting graph. No statuses or anything - it 
     * is up to you to show progress etc.
     * @return the graph 
     */
    public Graph getGraph();
  
    public Graph getGraph(String nodes, Component c);
}
