/*
 * MedusaSimplerFrame.java
 *
 * Created on November 13, 2008, 5:23 PM
 */
package medusa;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.JOptionPane;
import javax.swing.ProgressMonitor;
import javax.swing.Timer;
import java.awt.Cursor;
import java.awt.FileDialog;
import java.awt.Frame;
import java.awt.event.KeyEvent;
import javax.jnlp.UnavailableServiceException;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JColorChooser;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.KeyStroke;
import javax.swing.border.Border;
import medusa.dataio.DataLoader;
import medusa.display.EditableGraphPanel;
import medusa.georgios.Layouts.Layouts;
import medusa.graph.Graph;
import medusa.graph.Node;
import medusa.graphedit.EditGraphDialog;

/**
 *
 * @author  Georgios
 */
public class MedusaSimplerFrame extends javax.swing.JFrame {
//---------------------------------------------------------------------------------------------------

	MedusaSettings stringSettings;
	public static EditableGraphPanel stringletPanel;
	static final Color darkBackground = new Color(0.33f, 0.0f, 0.0f);
	static final Color foreground = new Color(1.0f, 1.0f, 1.0f);
	static double oldScale = 1.0;
	static double scale = 1.0;
	JLabel startinglabel;
	public static final String version = "1.";
	public static final Color STRINGCOLOR = new Color(161, 173, 236);
	Color background = STRINGCOLOR;
	String lastDir = null;
	String lastFile = null;
	String lastInter = null;
	private boolean hideInteractions = false;
	public static JScrollPane jScrollPane;
	ProgressMonitor loader;
	Timer timer;
	DataLoader dl;
	Frame f = new Frame();
	EditGraphDialog egd;
	ShowEdgeMultiPanel multiedgepanel = new ShowEdgeMultiPanel();
	Border graphBorder = BorderFactory.createRaisedBevelBorder();
//---------------------------------------------------------------------------------------------------

	public MedusaSimplerFrame() {
		this.setPreferredSize(new java.awt.Dimension(700, 700));
		stringSettings = new MedusaSettings();
		stringletPanel = new EditableGraphPanel(stringSettings);
		stringletPanel.setBasicEdgeColor(java.awt.Color.black);
		stringletPanel.setTimeFrameXY(600, 600);
		stringletPanel.setBorder(graphBorder);
		stringletPanel.setShowBorder(false);
		stringletPanel.setArrows(false);
		stringletPanel.setCool(true);
		jScrollPane = new JScrollPane(stringletPanel);
		egd = new EditGraphDialog(this, true);
		show_starting_background();
		initComponents();

		this.add(jScrollPane);


//		jMenuItem4.setPreferredSize(new java.awt.Dimension(200, 180));
//		jMenuItem4.add(multiedgepanel);
//		jMenuItem4.repaint();

		SliderZooming slider = new SliderZooming();
		jMenuItem1.setPreferredSize(new java.awt.Dimension(slider.getPreferredSize().width + 25, slider.getPreferredSize().height + 5));
		jMenuItem1.setLayout(new BorderLayout());
		jMenuItem1.add(slider);
		jMenuItem1.repaint();


	}

//---------------------------------------------------------------------------------------------------
	private void stringConnection() {
		JOptionPane.showConfirmDialog(this, "STRING requires a license and is not\navailable to open source",
				"Disabled", JOptionPane.PLAIN_MESSAGE, JOptionPane.INFORMATION_MESSAGE);
	}
//---------------------------------------------------------------------------------------------------

	private void show_starting_background() {
		ImageIcon startingIcon = new ImageIcon(getClass().getResource("/medusa/images/welcome.jpg"));
		startinglabel = new JLabel();
		startinglabel.setIcon(startingIcon);
		stringletPanel.add(startinglabel);
		// stringletPanel.setBackgroundColor(new Color(161,173,236));
		stringletPanel.repaint();
	}

	private void hide_starting_background() {
		startinglabel.setVisible(false);
		stringletPanel.repaint();
	}

	//---------------------------------------------------------------------------------------------------
	private void setShapeEvent() {
		Object[] shapes = {"circle", "rectangle", "triangle", "diamond"};
		int s = JOptionPane.showOptionDialog(this,
				"Choose a node shape",
				"Shape",
				JOptionPane.YES_NO_CANCEL_OPTION,
				JOptionPane.QUESTION_MESSAGE,
				null,
				shapes,
				"circle");
		// If a string was returned, say so.
		stringletPanel.setShape(s);
		//System.out.println("Green eggs and... " + s + "!");
		return;
	}
//---------------------------------------------------------------------------------------------------

	public void loadImageEvent() {
		stringletPanel.stop();
		FileDialog fdLoad = new FileDialog(this, "Load image", FileDialog.LOAD);
		fdLoad.setVisible(true);
		String loadFile = fdLoad.getFile();
		String dir = fdLoad.getDirectory();
		if (loadFile != null) {
			try {
				stringletPanel.setImage(dir + loadFile);
			} catch (IOException ie) {
				JOptionPane.showMessageDialog(this, "The image could not be found or opened",
						"Load Error", JOptionPane.ERROR_MESSAGE);
			}
		}
		stringletPanel.repaint();
	}
//---------------------------------------------------------------------------------------------------

	private void stopAllRelax() {
		stringletPanel.stop();
	}
//---------------------------------------------------------------------------------------------------

	public void clearImageEvent() {
		stopAllRelax();
		stringletPanel.clearImage();
		stringletPanel.repaint();
	}
//---------------------------------------------------------------------------------------------------

	public void quitApplication() {
		stopAllRelax();
		System.out.println("Closing application");
//		try {
//			saveSettings();
//			System.out.println("Current settings saved");
//		} catch (IOException ie) {
//			System.out.println("...settings not saved due to file problems");
//		}
		remove(stringletPanel);
		System.exit(0);
	}
//---------------------------------------------------------------------------------------------------

	public void scaleOut() {
		double scale = 1.0;
		stringletPanel.setScale(scale / oldScale);
		Dimension d = stringletPanel.getSize();
		stringletPanel.setTimeFrameXY(d);
		oldScale = scale;
		stringletPanel.repaint();
		stringletPanel.revalidate();
		//jScrollPane.setPreferredSize(stringletPanel.getSize());
		//System.out.println(stringletPanel.getSize());
		jScrollPane.revalidate();
	}

	public static void setScale(JSlider src) {

		Dimension d = stringletPanel.getSize();
		//Dimension d = jScrollPane.getSize();
		double scale = (double) src.getValue() / 100;
		stringletPanel.setScale(scale / oldScale);
		stringletPanel.setTimeFrameXY(d);
		oldScale = scale;
		stringletPanel.repaint();
		stringletPanel.revalidate();
		jScrollPane.revalidate();
	}

	public void setScale(int scaleValue) {
		Dimension d = stringletPanel.getSize();
		//Dimension d = jScrollPane.getSize();
		double scale = (double) scaleValue / 100;
		stringletPanel.setScale(scale / oldScale);
		//stringletPanel.setScale(scale);
		stringletPanel.setTimeFrameXY(d);
		oldScale = scale;
		stringletPanel.repaint();
		stringletPanel.revalidate();
		jScrollPane.revalidate();
	}
//---------------------------------------------------------------------------------------------------

//	// this is for saving settings
//	public void saveSettings() throws IOException {
//		//System.out.println(lastDir);
//		if (lastDir != null) {
//			File saveFile = new File("NetViewSettings.ini");
//			FileWriter out = new FileWriter(saveFile);
//			out.write("LASTDIR=");
//			out.write(lastDir + "\n");
//
//			// write interaction file
//			if (lastInter != null) {
//				out.write("INTERACT=");
//				out.write(lastInter + "\n");
//			}
//			out.close();
//		}
//	}
////---------------------------------------------------------------------------------------------------
//
//	private boolean loadSettings() throws IOException {
//		File loadFile = new File("NetViewSettings.ini");
//		BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(loadFile)));
//		String inLine = in.readLine();
//		if (inLine == null) {
//			System.out.println("Error in NetViewSettings.ini");
//			return false;
//		}
//		// get last dir
//		Pattern dirPattern = Pattern.compile("LASTDIR=(.+)");
//		Matcher matcher = dirPattern.matcher(inLine);
//		//System.out.println(inLine);
//		if (matcher.find()) {
//			lastDir = matcher.group(1);
//		//System.out.println("Reading line "+lastDir);
//
//		} else {
//			//System.out.println("returning false from loadsettings");
//			return false;
//		}
//		// get last interaction file
//		inLine = in.readLine();
//		if (inLine != null) {
//			Pattern interPattern = Pattern.compile("INTERACT=(\\w+)");
//			matcher = interPattern.matcher(inLine);
//			if (matcher.find()) {
//				lastInter = matcher.group(1);
//			}
//		}
//		in.close();
//		return true;
//	}
////---------------------------------------------------------------------------------------------------
//
//	private String getFixedNodesAsString() {
//		StringBuffer sb = new StringBuffer();
//		sb.append("");
//		java.util.ArrayList nodeArray = stringletPanel.getFixed();
//		for (java.util.Iterator i = nodeArray.iterator(); i.hasNext();) {
//			Node n = (Node) i.next();
//			sb.append(n.getLabel());
//			sb.append("\n");
//		}
//		return sb.toString();
//	}
//---------------------------------------------------------------------------------------------------
	private void proteinInteractionEvent() {
		stringSettings.clear();
		stringSettings.init();
		//  updateLegend();
		stringletPanel.updateStringSettings(stringSettings);
	// legendPanel.repaint();
	}
//---------------------------------------------------------------------------------------------------

	private void cogInteractionEvent() {
		stringSettings.clear();
		stringSettings.initCOGS();
		//  updateLegend();
		stringletPanel.updateStringSettings(stringSettings);
	//   legendPanel.repaint();

	}
//---------------------------------------------------------------------------------------------------

	private void setEdgeLenEvent() {
		int len = (int) stringletPanel.getEdgeLen();
		String s = (String) JOptionPane.showInputDialog("Enter desired edge length in pixels:\n" + "Set to 0 for default length",
				String.valueOf(len));
		if ((s != null) && (s.length() > 0)) {
			try {
				int newSize = Integer.parseInt(s);
				stringletPanel.setEdgeLen(newSize);
			} catch (NumberFormatException ne) {
				JOptionPane.showMessageDialog(this, "Incorrect input",
						"An integer is required for this action",
						JOptionPane.ERROR_MESSAGE);
			}
		}
	}

//---------------------------------------------------------------------------------------------------
	public void updateInfo() {
		String[] result = stringletPanel.getGraphData();
	}
//---------------------------------------------------------------------------------------------------

	public void waitForLoad(String fileName, int loadType)
			throws IOException, DataFormatException {
		hide_starting_background();
		dl = new DataLoader(600, 600, fileName);
		dl.setLoadType(loadType);
		timer = new javax.swing.Timer(500, runLoad);
		dl.start();
		timer.start();
		setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
	}
//---------------------------------------------------------------------------------------------------
	private ActionListener runLoad = new ActionListener() {

		public void actionPerformed(ActionEvent evt) {
//            infoLabel.setText(dl.getStatus() + " " + dl.getProgress());
			//loader.setProgress(0);
			//System.out.println(dl.getProgress());
			if (dl.isDone()) {
				timer.stop();
				dl.stop();
				//loader.close();
				//loader.setProgress(0);
//                infoLabel.setText("Cleaning graph");
				setCursor(null);
				stringletPanel.setGraph(dl.getGraph());
				updateInfo();
				String[] result = stringletPanel.getGraphData();
				String display = "<html><b>nodes: " +
						result[0] + "<br>edges: " + result[1] +
						"<br>" + lastFile + "</b></html>";
				JOptionPane.showMessageDialog(MedusaSimplerFrame.stringletPanel, display);
				stringletPanel.repaint();
			}
		}
	};
//---------------------------------------------------------------------------------------------------

//    private void hideShowInteractionsEvent() {
//        Container content = getContentPane();
//        if (!hideInteractions) {
//            //   content.remove(scalerPanel);
//            hideInteractions = true;
//        } else {
//            //   content.add("East", scalerPanel);
//            hideInteractions = false;
//        }
//        validate();
//
//    }
//---------------------------------------------------------------------------------------------------
	public static void setNodeColorSet(int i) {
		stringletPanel.setNodeColorSet(i);
		stringletPanel.repaint();
	}

//---------------------------------------------------------------------------------------------------
	private void loadEvent(int loadType) {
		stopAllRelax();
		scaleOut();
		FileDialog fdLoad = new FileDialog(this, "Load graph", FileDialog.LOAD);
		if (lastDir != null) {
			fdLoad.setDirectory(lastDir);
		}
		fdLoad.setFilenameFilter(new DataFileFilter());
		fdLoad.setVisible(true);
		String loadFile = fdLoad.getFile();
		String dir = fdLoad.getDirectory();
		if (loadFile != null) {
			try {
				//stringletPanel.loadGraph(dir+loadFile);
				waitForLoad(dir + loadFile, loadType);
				lastDir = dir;
				lastFile = loadFile;
			//System.out.println(lastFile);
			} catch (IOException ie) {
				ie.printStackTrace();
				JOptionPane.showMessageDialog(this, "The file could not be found or opened",
						"Load Error", JOptionPane.ERROR_MESSAGE);
			} catch (DataFormatException dfe) {
				JOptionPane.showMessageDialog(this, dfe.getMessage(),
						"Data Error", JOptionPane.ERROR_MESSAGE);

			//System.exit(0);
			}
		}
	}
//---------------------------------------------------------------------------------------------------

	private void addGraphEvent() {
		stopAllRelax();
		scaleOut();
		FileDialog fdLoad = new FileDialog(this, "Add graph", FileDialog.LOAD);
		if (lastDir != null) {
			fdLoad.setFile(lastDir + lastFile);
		}
		fdLoad.setFilenameFilter(new DataFileFilter());
		fdLoad.setVisible(true);
		String loadFile = fdLoad.getFile();
		String dir = fdLoad.getDirectory();
		if (loadFile != null) {
			try {

				stringletPanel.appendGraph(dir + loadFile);

				lastDir = dir + loadFile;
				lastFile = loadFile;
				updateInfo();
				stringletPanel.repaint();
			} catch (IOException ie) {
				//ie.printStackTrace();
				JOptionPane.showMessageDialog(this, "The file could not be found or opened",
						"Load Error", JOptionPane.ERROR_MESSAGE);

			} catch (DataFormatException dfe) {

				JOptionPane.showMessageDialog(this, dfe.getMessage(),
						"Data Error", JOptionPane.ERROR_MESSAGE);

			//System.exit(0);
			}
		}
	}
//---------------------------------------------------------------------------------------------------

	private void subtractGraphEvent() {
		stopAllRelax();
		scaleOut();
		FileDialog fdLoad = new FileDialog(this, "Add graph", FileDialog.LOAD);
		if (lastDir != null) {
			fdLoad.setFile(lastDir + lastFile);
		}
		fdLoad.setFilenameFilter(new DataFileFilter());
		fdLoad.setVisible(true);
		String loadFile = fdLoad.getFile();
		String dir = fdLoad.getDirectory();
		if (loadFile != null) {
			try {

				stringletPanel.subtractGraph(dir + loadFile);

				lastDir = dir + loadFile;
				lastFile = loadFile;
				updateInfo();
				stringletPanel.repaint();
			} catch (IOException ie) {
				//ie.printStackTrace();
				JOptionPane.showMessageDialog(this, "The file could not be found or opened",
						"Load Error", JOptionPane.ERROR_MESSAGE);

			} catch (DataFormatException dfe) {

				JOptionPane.showMessageDialog(this, dfe.getMessage(),
						"Data Error", JOptionPane.ERROR_MESSAGE);

			//System.exit(0);
			}
		}
	}
	//---------------------------------------------------------------------------------------------------

	private void saveEvent() {
//        FileDialog fdSave = new FileDialog(this, "Save as", FileDialog.SAVE);
//        //fdSave.setDirectory(fdDirectory);
//        fdSave.setFilenameFilter(new DataFileFilter());
//        fdSave.setVisible(true);
//        String saveFile = fdSave.getFile();
//        String dir = fdSave.getDirectory();
//        if (saveFile != null) {
//            lastDir = dir;
//            lastFile = saveFile;
//            try {
//                stringletPanel.saveGraph(dir + saveFile);
//            } catch (IOException ie) {
//                JOptionPane.showMessageDialog(this, "Error saving file.",
//                        "Save error", JOptionPane.ERROR_MESSAGE);
//            }
//
//        }

		try {
			stringletPanel.saveGraph("");
		} catch (IOException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		} catch (UnavailableServiceException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		}
	}
//---------------------------------------------------------------------------------------------------

	private void copyGraphEvent() {
		stopAllRelax();
		scaleOut();
		FileDialog fdLoad = new FileDialog(this, "Add graph", FileDialog.LOAD);
		if (lastDir != null) {
			fdLoad.setFile(lastDir + lastFile);
		}
		fdLoad.setFilenameFilter(new DataFileFilter());
		fdLoad.setVisible(true);
		String loadFile = fdLoad.getFile();
		String dir = fdLoad.getDirectory();
		if (loadFile != null) {
			try {

				stringletPanel.copyGraphSettings(dir + loadFile);

				lastDir = dir + loadFile;
				lastFile = loadFile;
				updateInfo();
				stringletPanel.repaint();
			} catch (IOException ie) {
				//ie.printStackTrace();
				JOptionPane.showMessageDialog(this, "The file could not be found or opened",
						"Load Error", JOptionPane.ERROR_MESSAGE);

			} catch (DataFormatException dfe) {

				JOptionPane.showMessageDialog(this, dfe.getMessage(),
						"Data Error", JOptionPane.ERROR_MESSAGE);

			//System.exit(0);
			}
		}
	}
//---------------------------------------------------------------------------------------------------

	private void exportImageEvent(boolean png) {
//		String name = "network." + ((png) ? "png" : "jpg");
//		FileDialog fdSave = new FileDialog(this, "Save as " + ((png) ? "png" : "jpg"), FileDialog.SAVE);
//		fdSave.setFile(name);
//		//fdSave.setFilenameFilter(new CustomFileFilter("\\.ps"));
//		fdSave.setVisible(true);
//		String saveFile = fdSave.getFile();
//		if (saveFile == null) {
//			return;
//		}
//		String dir = fdSave.getDirectory();
		int type = (png) ? 1 : 0;

		stringletPanel.saveImage("", type);
		JOptionPane.showMessageDialog(this, "Panel exported",
				"Image saved", JOptionPane.INFORMATION_MESSAGE);
	}
//---------------------------------------------------------------------------------------------------

	private void exportPajekEvent() {
		FileDialog fdSave = new FileDialog(this, "Save as pajek", FileDialog.SAVE);
		fdSave.setVisible(true);
		String saveFile = fdSave.getFile();
		String dir = fdSave.getDirectory();
		if (saveFile != null) {
			//lastDir=dir+saveFile;
			try {
				stringletPanel.writePajek(dir + saveFile + ".pajek");
				JOptionPane.showMessageDialog(this, "Exported to pajek format " + saveFile + ".pajek",
						"Pajek", JOptionPane.INFORMATION_MESSAGE);
			//System.out.println("weng MedusaFrame exportPSEvent");
			} catch (IOException ie) {
				JOptionPane.showMessageDialog(this, "Error saving file.",
						"Save error", JOptionPane.ERROR_MESSAGE);
			}

		}
	}
	//---------------------------------------------------------------------------------------------------

	private void exportArena3DEvent() {
		FileDialog fdSave = new FileDialog(this, "Save as Arena3d", FileDialog.SAVE);
		fdSave.setVisible(true);
		String saveFile = fdSave.getFile();
		String dir = fdSave.getDirectory();
		if (saveFile != null) {
			//lastDir=dir+saveFile;
			try {
				stringletPanel.writeArena3D(dir + saveFile + ".a3d");
				JOptionPane.showMessageDialog(this, "Exported to Arena3D format " + saveFile + ".a3d",
						"Arena3D", JOptionPane.INFORMATION_MESSAGE);
			//System.out.println("weng MedusaFrame exportPSEvent");
			} catch (IOException ie) {
				JOptionPane.showMessageDialog(this, "Error saving file.",
						"Save error", JOptionPane.ERROR_MESSAGE);
			}

		}
	}
//---------------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------------

	private void exportCytoscapeEvent() {
//		FileDialog fdSave = new FileDialog(this, "Save as Cytoscape", FileDialog.SAVE);
//		fdSave.setVisible(true);
//		String saveFile = fdSave.getFile();
//		String dir = fdSave.getDirectory();
//		if (saveFile != null) {
		//lastDir=dir+saveFile;
		try {
			stringletPanel.writeCytoscape("");
			JOptionPane.showMessageDialog(this, "Exported to Cytoscape format",
					"Cytoscape", JOptionPane.INFORMATION_MESSAGE);
		//System.out.println("weng MedusaFrame exportPSEvent");
		} catch (IOException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		} catch (UnavailableServiceException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		}
//		}
	}
//---------------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------------

	private void exportGraphVizEvent() {
//		FileDialog fdSave = new FileDialog(this, "Save as GraphViz", FileDialog.SAVE);
//		fdSave.setVisible(true);
//		String saveFile = fdSave.getFile();
//		String dir = fdSave.getDirectory();
//		if (saveFile != null) {
		//lastDir=dir+saveFile;
		try {
			stringletPanel.writeGraphViz("");
			JOptionPane.showMessageDialog(this, "Exported to GraphViz format",
					"GraphViz", JOptionPane.INFORMATION_MESSAGE);
		//System.out.println("weng MedusaFrame exportPSEvent");
		} catch (IOException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		} catch (UnavailableServiceException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		}
//		}
	}
//---------------------------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------------------------

	private void exportBiolayoutEvent() {
		FileDialog fdSave = new FileDialog(this, "Save as Biolayout Express 3D", FileDialog.SAVE);
		fdSave.setVisible(true);
		String saveFile = fdSave.getFile();
		String dir = fdSave.getDirectory();
		if (saveFile != null) {
			//lastDir=dir+saveFile;
			try {
				stringletPanel.writeBiolayout(dir + saveFile + ".layout");
				JOptionPane.showMessageDialog(this, "Exported to Biolayout Express 3D format " + saveFile + ".layout",
						"Biolayout Express 3D", JOptionPane.INFORMATION_MESSAGE);
			//System.out.println("weng MedusaFrame exportPSEvent");
			} catch (IOException ie) {
				JOptionPane.showMessageDialog(this, "Error saving file.",
						"Save error", JOptionPane.ERROR_MESSAGE);
			}

		}
	}
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------

	private void saveHTMLParametersEvent() {
		FileDialog fdSave = new FileDialog(this, "Save applet parameters to", FileDialog.SAVE);
		fdSave.setVisible(true);
		String saveFile = fdSave.getFile();
		dl = new DataLoader();
		//System.out.println(stringletPanel.getGraph().report());
		if (saveFile != null) {
			try {
				dl.saveHTMLParameters(stringletPanel.getGraph(), saveFile);

			} catch (IOException ie) {
				JOptionPane.showMessageDialog(this, "Error saving file.",
						"Save error", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
//---------------------------------------------------------------------------------------------------

	public void stopRelax() {
		stringletPanel.stop();
	}
//---------------------------------------------------------------------------------------------------

	private void searchNodeEvent(boolean label) {
		String s = (String) JOptionPane.showInputDialog("Mark node matching regular expression:\n" + "e.g. \"mito.*\"",
				"");
		//stringletPanel.findLabel
		if (s != null) {
			if (stringletPanel.selectNodeByRegExp(s, label) == 0) {
				JOptionPane.showMessageDialog(this, "No match found",
						"No nodes matching your pattern were found",
						JOptionPane.ERROR_MESSAGE);
			}
		}
		stringletPanel.repaint();
	}
	//---------------------------------------------------------------------------------------------------

	private void selectNodeFromFileEvent() {
		FileDialog fdSelect = new FileDialog(this, "Load node list", FileDialog.LOAD);
		if (lastDir != null) {
			fdSelect.setDirectory(lastDir);
		}
		fdSelect.setVisible(true);
		String loadFile = fdSelect.getFile();
		String dir = fdSelect.getDirectory();
		//lastDir=dir;

		try {
			int c = stringletPanel.selectNodeFromFile(dir + loadFile);
			stringletPanel.repaint();
		} catch (IOException sNFFe) {
			JOptionPane.showMessageDialog(this, sNFFe.getMessage(),
					"Load Error", JOptionPane.ERROR_MESSAGE);

		}
	}
//---------------------------------------------------------------------------------------------------

	private void changeNodeSizeEvent() {
		String s = (String) JOptionPane.showInputDialog("Enter node size in pixels:\n" + "Default value is 10",
				"");
		int newSize = -1; // default if something goes wrong
		if ((s != null) && (s.length() > 0)) {
			try {
				newSize = Integer.parseInt(s);
				stringletPanel.setNodeSize(newSize);
			} catch (NumberFormatException ne) {
				JOptionPane.showMessageDialog(this, "Incorrect input",
						"An integer is required for this action",
						JOptionPane.ERROR_MESSAGE);
			}
		}
		stringletPanel.repaint();
	}
//---------------------------------------------------------------------------------------------------

	private void changeColorEvent() {
		Color newColor = JColorChooser.showDialog(getRootPane(),
				"Choose node color",
				Color.red);
		if (newColor != null) {
			stringletPanel.changeNodeColor(newColor);

			stringletPanel.repaint();
		}
	}
//---------------------------------------------------------------------------------------------------

	private void setLabelColorEvent() {
		Color newColor = JColorChooser.showDialog(getRootPane(),
				"Choose label color",
				Color.black);
		if (newColor != null) {
			stringletPanel.setFontColor(newColor);

			stringletPanel.repaint();
		}
	}
//---------------------------------------------------------------------------------------------------

	private void setBackgroundColorEvent() {
		Color newColor = JColorChooser.showDialog(getRootPane(),
				"Choose label color",
				Color.white);
		if (newColor != null) {
			stringletPanel.setBackgroundColor(newColor);

			stringletPanel.repaint();
		}
	}

//---------------------------------------------------------------------------------------------------
	private void setBasicEdgeColorEvent() {
		Color newColor = JColorChooser.showDialog(getRootPane(),
				"Choose label color",
				Color.gray);
		if (newColor != null) {
			stringletPanel.setBasicEdgeColor(newColor);

			stringletPanel.repaint();
		}
	}
//---------------------------------------------------------------------------------------------------

	private void changeFontSizeEvent() {
		String s = (String) JOptionPane.showInputDialog("Enter font size:\n" + "Default value is 10",
				"");
		if ((s != null) && (s.length() > 0)) {
			try {
				int newSize = Integer.parseInt(s);
				stringletPanel.changeFont(newSize);
			} catch (NumberFormatException ne) {
				JOptionPane.showMessageDialog(this, "Incorrect input",
						"An integer is required for this action",
						JOptionPane.ERROR_MESSAGE);
			}
		}
		stringletPanel.repaint();
	}
//---------------------------------------------------------------------------------------------------

	private void switchColorEvent() {
		int[] colors = ColorJDialog.showDialog(f, null, "switch with");
		stringletPanel.manipulateColor(colors[0], colors[1], true);
		stringletPanel.repaint();

	}
//---------------------------------------------------------------------------------------------------

	private void copyColorEvent() {
		int[] colors = ColorJDialog.showDialog(f, null, "copy to");
		stringletPanel.manipulateColor(colors[0], colors[1], false);
		stringletPanel.repaint();
	}
//---------------------------------------------------------------------------------------------------

	private void interactionEvent() {
		FileDialog fdInter = new FileDialog(this, "Load interaction file", FileDialog.LOAD);
		fdInter.setVisible(true);
		String loadFile = fdInter.getFile();
		String dir = fdInter.getDirectory();
		if (loadFile != null) {
			try {
				lastInter = dir + loadFile;
				stringSettings.load(dir + loadFile);
				//updateLegend();
				stringletPanel.updateStringSettings(stringSettings);
			//legendPanel.repaint();
			//stringSettings.report();
			} catch (IOException ie) {
				//ie.printStackTrace();
				JOptionPane.showMessageDialog(this, "Interaction settings could not be loaded.\n" +
						"Check if the file is valid.",
						"Load error", JOptionPane.ERROR_MESSAGE);
			}

		}
	}
//---------------------------------------------------------------------------------------------------

	private void editGraph() {
		stopAllRelax();
		egd = new EditGraphDialog(this, true);
		egd.setGraph(stringletPanel.getGraph());
		egd.setVisible(true);
		Graph g = egd.getGraph();
		if (g != null) {

			stringletPanel.setGraph(g);

			stringletPanel.repaint();
		}
	}
//---------------------------------------------------------------------------------------------------

	private void clearGraphEvent() {
		stopAllRelax();
		if (yes_no("Your data will be lost. Are you sure?") == 0) {
			stringletPanel.clearGraph();
			stringletPanel.repaint();
			updateInfo();
		}
	}
//---------------------------------------------------------------------------------------------------
	// a yes/no dialogue

	private int yes_no(String message) {
		int s = JOptionPane.showConfirmDialog(this,
				message,
				"Confirm",
				JOptionPane.YES_NO_OPTION);

		return s;
	}
//---------------------------------------------------------------------------------------------------

	private void rotateEvent(double degrees) {
		stopAllRelax();
		stringletPanel.rotate(degrees);
		stringletPanel.repaint();
	}
//---------------------------------------------------------------------------------------------------

	private void getRandomGraphEvent() {

		int s = yes_no("This will generate a random graph. Are you sure?");
		//System.out.println(s);
		if (s == 0) {
			stopAllRelax();
			stringletPanel.randomGraph(30, 60);
			updateInfo();
			stringletPanel.repaint();
		}
	}
//---------------------------------------------------------------------------------------------------

	private void recalcEvent() {
		stopAllRelax();
		if (yes_no("This will return edge length \nand orientation to default values\n Are you sure you want to do this?") == 0) {
			stringletPanel.autoFixOrientation();
			stringletPanel.calculateEdgeLength();
			stringletPanel.repaint();

		}
	}
//---------------------------------------------------------------------------------------------------

	public static void handleEdgeEvent(int number, boolean selected) {
		//System.out.println("set "+number+" to "+selected);
		stringletPanel.setShowEdge(number - 1, selected);
		stringletPanel.repaint();
	}
//---------------------------------------------------------------------------------------------------

	private void exportEPSEvent() {
//		FileDialog fdSave = new FileDialog(this, "Save as EPS", FileDialog.SAVE);
//        //fdSave.setDirectory(fdDirectory);
//        //fdSave.setFilenameFilter(new CustomFileFilter("\\.ps"));
//        fdSave.setVisible(true);
//        String saveFile = fdSave.getFile();
//        String dir = fdSave.getDirectory();
//        if (saveFile != null) {
//            //lastDir=dir+saveFile;
//            try {
//                stringletPanel.writeEPS(dir + saveFile);
//                //System.out.println("weng MedusaFrame exportPSEvent");
//                JOptionPane.showMessageDialog(this, "Panel exported to " + saveFile,
//                        "EPS saved", JOptionPane.INFORMATION_MESSAGE);
//            } catch (IOException ie) {
//                JOptionPane.showMessageDialog(this, "Error saving file.",
//                        "Save error", JOptionPane.ERROR_MESSAGE);
//            }
//
//        }
		try {
			stringletPanel.writeEPS("");
			//System.out.println("weng MedusaFrame exportPSEvent");
			JOptionPane.showMessageDialog(this, "Panel exported",
					"EPS saved", JOptionPane.INFORMATION_MESSAGE);
		} catch (IOException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		} catch (UnavailableServiceException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		}
	}
//---------------------------------------------------------------------------------------------------

	private void exportPSEvent() {
//		FileDialog fdSave = new FileDialog(this, "Save as PS", FileDialog.SAVE);
//		//fdSave.setDirectory(fdDirectory);
//		//fdSave.setFilenameFilter(new CustomFileFilter("\\.ps"));
//		fdSave.setVisible(true);
//		String saveFile = fdSave.getFile();
//		String dir = fdSave.getDirectory();
//		if (saveFile != null) {
//			//lastDir=dir+saveFile;
//			try {
//				stringletPanel.writePS(dir + saveFile);
//				JOptionPane.showMessageDialog(this, "Panel exported to " + saveFile,
//						"PS saved", JOptionPane.INFORMATION_MESSAGE);
//			//System.out.println("weng MedusaFrame exportPSEvent");
//			} catch (IOException ie) {
//				JOptionPane.showMessageDialog(this, "Error saving file.",
//						"Save error", JOptionPane.ERROR_MESSAGE);
//			}
//
//		}
		try {
			stringletPanel.writePS("");
			JOptionPane.showMessageDialog(this, "Panel exported",
					"PS saved", JOptionPane.INFORMATION_MESSAGE);
		//System.out.println("weng MedusaFrame exportPSEvent");
		} catch (IOException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		} catch (UnavailableServiceException ie) {
			JOptionPane.showMessageDialog(this, "Error saving file.",
					"Save error", JOptionPane.ERROR_MESSAGE);
		}
	}
//---------------------------------------------------------------------------------------------------

	public void alignNodes(int align) {
		if (stringletPanel.getFixed().size() < 2) {
			JOptionPane.showMessageDialog(this, "You must select at least two nodes",
					"Error", JOptionPane.ERROR_MESSAGE);
			return;
		}
		stringletPanel.alignNodes(align);
		stringletPanel.repaint();

	}
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jMenuBar1 = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        saveMenuItem = new javax.swing.JMenuItem();
        exportMenu = new javax.swing.JMenu();
        exportImageMenu = new javax.swing.JMenu();
        exportJPGMenuItem = new javax.swing.JMenuItem();
        exportPNGMenuItem = new javax.swing.JMenuItem();
        exportPostscriptMenu = new javax.swing.JMenu();
        exportPSMenuItem = new javax.swing.JMenuItem();
        exportEPSMenuItem = new javax.swing.JMenuItem();
        jMenuItem7 = new javax.swing.JMenuItem();
        jMenuItem8 = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        quitMenuItem = new javax.swing.JMenuItem();
        layoutMenu = new javax.swing.JMenu();
        randomMenuItem = new javax.swing.JMenuItem();
        circularMenuItem = new javax.swing.JMenuItem();
        gridMenuItem = new javax.swing.JMenuItem();
        jSeparator9 = new javax.swing.JSeparator();
        relaxMenu = new javax.swing.JMenu();
        startRelaxMenuItem = new javax.swing.JMenuItem();
        stopRelaxMenuItem = new javax.swing.JMenuItem();
        temperatureButton = new javax.swing.JCheckBoxMenuItem();
        jSeparator10 = new javax.swing.JSeparator();
        fruchtermanMenuItem = new javax.swing.JMenuItem();
        hierarchicalMenuItem = new javax.swing.JMenuItem();
        distanceGeometryMenuItem = new javax.swing.JMenuItem();
        clusteringMenu = new javax.swing.JMenu();
        kmeansMenuItem = new javax.swing.JMenuItem();
        affinityMenuItem = new javax.swing.JMenuItem();
        mclMenuItem = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();
        zoomMenu = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        selectMenu = new javax.swing.JMenu();
        selectAllMenuItem = new javax.swing.JMenuItem();
        selectNoneMenuItem = new javax.swing.JMenuItem();
        selectNodeLabelByRegExpMenuItem = new javax.swing.JMenuItem();
        selectNodeAnnotationByRegExpMenuItem = new javax.swing.JMenuItem();
        invertFixMenuItem = new javax.swing.JMenuItem();
        selectGrowMenuItem = new javax.swing.JMenuItem();
        optionMenu = new javax.swing.JMenu();
        jMenuItem3 = new javax.swing.JMenuItem();
        changeNodeSizeMenuItem = new javax.swing.JMenuItem();
        setEdgeLenMenuItem = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        colorMenu = new javax.swing.JMenu();
        changeColorMenuItem = new javax.swing.JMenuItem();
        switchColorMenuItem = new javax.swing.JMenuItem();
        copyColorMenuItem = new javax.swing.JMenuItem();
        jSeparator4 = new javax.swing.JSeparator();
        setBasicEdgeColorMenuItem = new javax.swing.JMenuItem();
        setBackgroundColorMenuItem = new javax.swing.JMenuItem();
        fontMenu = new javax.swing.JMenu();
        setLabelColorMenuItem = new javax.swing.JMenuItem();
        changeFontSizeMenuItem = new javax.swing.JMenuItem();
        manipulateMenu = new javax.swing.JMenu();
        cropMenuItem = new javax.swing.JMenuItem();
        rotateMenu = new javax.swing.JMenu();
        rotateRightMenuItem = new javax.swing.JMenuItem();
        rotateLeftMenuItem = new javax.swing.JMenuItem();
        flipMenu = new javax.swing.JMenu();
        flipXItem = new javax.swing.JMenuItem();
        flipYItem = new javax.swing.JMenuItem();
        alignNodesMenu = new javax.swing.JMenu();
        alignTop = new javax.swing.JMenuItem();
        alignBottom = new javax.swing.JMenuItem();
        alignLeft = new javax.swing.JMenuItem();
        alignRight = new javax.swing.JMenuItem();
        jSeparator5 = new javax.swing.JSeparator();
        recalcButton = new javax.swing.JMenuItem();
        displayMenu = new javax.swing.JMenu();
        prettyCBMItem = new javax.swing.JCheckBoxMenuItem();
        namesCBMItem = new javax.swing.JCheckBoxMenuItem();
        showNamesCBMItem = new javax.swing.JCheckBoxMenuItem();
        directedCBMItem = new javax.swing.JCheckBoxMenuItem();
        confidenceCBMItem = new javax.swing.JCheckBoxMenuItem();
        alphaCBMItem = new javax.swing.JCheckBoxMenuItem();
        jSeparator7 = new javax.swing.JSeparator();
        hideWhenMoveCBMItem = new javax.swing.JCheckBoxMenuItem();
        jSeparator8 = new javax.swing.JSeparator();
        nodeColorDisplayMenu = new javax.swing.JMenu();
        channel1MenuItem = new javax.swing.JRadioButtonMenuItem();
        channel2MenuItem = new javax.swing.JRadioButtonMenuItem();
        channel3MenuItem = new javax.swing.JRadioButtonMenuItem();
        jRadioButtonMenuItem1 = new javax.swing.JRadioButtonMenuItem();
        helpMenu = new javax.swing.JMenu();
        aboutMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Medusa 1.5");
        setBackground(new java.awt.Color(255, 255, 255));
        addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                formKeyTyped(evt);
            }
        });

        jMenuBar1.setBackground(new java.awt.Color(161, 173, 236));
        jMenuBar1.setForeground(new java.awt.Color(255, 255, 255));

        fileMenu.setForeground(new java.awt.Color(255, 255, 255));
        fileMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/medusa_logo_smaller.png"))); // NOI18N
        fileMenu.setText("File");

        saveMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_S, java.awt.event.InputEvent.CTRL_MASK));
        saveMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Save.gif"))); // NOI18N
        saveMenuItem.setText("Save");
        saveMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(saveMenuItem);

        exportMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/export.gif"))); // NOI18N
        exportMenu.setText("Export");

        exportImageMenu.setText("Image");

        exportJPGMenuItem.setText("JPG");
        exportJPGMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportJPGMenuItemActionPerformed(evt);
            }
        });
        exportImageMenu.add(exportJPGMenuItem);

        exportPNGMenuItem.setText("PNG");
        exportPNGMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportPNGMenuItemActionPerformed(evt);
            }
        });
        exportImageMenu.add(exportPNGMenuItem);

        exportMenu.add(exportImageMenu);

        exportPostscriptMenu.setText("PostScript");

        exportPSMenuItem.setText("PS");
        exportPSMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportPSMenuItemActionPerformed(evt);
            }
        });
        exportPostscriptMenu.add(exportPSMenuItem);

        exportEPSMenuItem.setText("EPS");
        exportEPSMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportEPSMenuItemActionPerformed(evt);
            }
        });
        exportPostscriptMenu.add(exportEPSMenuItem);

        exportMenu.add(exportPostscriptMenu);

        jMenuItem7.setText("Cytoscape");
        jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem7ActionPerformed(evt);
            }
        });
        exportMenu.add(jMenuItem7);

        jMenuItem8.setText("GraphViz");
        jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem8ActionPerformed(evt);
            }
        });
        exportMenu.add(jMenuItem8);

        fileMenu.add(exportMenu);
        fileMenu.add(jSeparator1);

        quitMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.CTRL_MASK));
        quitMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Application-cancel.gif"))); // NOI18N
        quitMenuItem.setText("Quit");
        quitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(quitMenuItem);

        jMenuBar1.add(fileMenu);

        layoutMenu.setForeground(new java.awt.Color(255, 255, 255));
        layoutMenu.setText("Layout");

        randomMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_R, java.awt.event.InputEvent.CTRL_MASK));
        randomMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Tag-Blue.gif"))); // NOI18N
        randomMenuItem.setText("Random");
        randomMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                randomMenuItemActionPerformed(evt);
            }
        });
        layoutMenu.add(randomMenuItem);

        circularMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, java.awt.event.InputEvent.CTRL_MASK));
        circularMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Tag-Green.gif"))); // NOI18N
        circularMenuItem.setText("Circular");
        circularMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                circularMenuItemActionPerformed(evt);
            }
        });
        layoutMenu.add(circularMenuItem);

        gridMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_G, java.awt.event.InputEvent.CTRL_MASK));
        gridMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Tag-Orange.gif"))); // NOI18N
        gridMenuItem.setText("Grid");
        gridMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                gridMenuItemActionPerformed(evt);
            }
        });
        layoutMenu.add(gridMenuItem);
        layoutMenu.add(jSeparator9);

        relaxMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Tag-Del.gif"))); // NOI18N
        relaxMenu.setText("Relax");

        startRelaxMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_SPACE, java.awt.event.InputEvent.CTRL_MASK));
        startRelaxMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Compile-Run.gif"))); // NOI18N
        startRelaxMenuItem.setText("Start relaxation");
        startRelaxMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startRelaxMenuItemActionPerformed(evt);
            }
        });
        relaxMenu.add(startRelaxMenuItem);

        stopRelaxMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_SPACE, java.awt.event.InputEvent.ALT_MASK | java.awt.event.InputEvent.CTRL_MASK));
        stopRelaxMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Compile-Cancel.gif"))); // NOI18N
        stopRelaxMenuItem.setText("Stop relaxation");
        stopRelaxMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stopRelaxMenuItemActionPerformed(evt);
            }
        });
        relaxMenu.add(stopRelaxMenuItem);

        temperatureButton.setSelected(true);
        temperatureButton.setText("Cooling");
        temperatureButton.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                temperatureButtonItemStateChanged(evt);
            }
        });
        relaxMenu.add(temperatureButton);

        layoutMenu.add(relaxMenu);
        layoutMenu.add(jSeparator10);

        fruchtermanMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.CTRL_MASK));
        fruchtermanMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Tag-Purple.gif"))); // NOI18N
        fruchtermanMenuItem.setText("Fruchterman");
        fruchtermanMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fruchtermanMenuItemActionPerformed(evt);
            }
        });
        layoutMenu.add(fruchtermanMenuItem);

        hierarchicalMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_H, java.awt.event.InputEvent.CTRL_MASK));
        hierarchicalMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Tag-Red.gif"))); // NOI18N
        hierarchicalMenuItem.setText("Hierarchical");
        hierarchicalMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                hierarchicalMenuItemActionPerformed(evt);
            }
        });
        layoutMenu.add(hierarchicalMenuItem);

        distanceGeometryMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, java.awt.event.InputEvent.CTRL_MASK));
        distanceGeometryMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Tag-Yellow.gif"))); // NOI18N
        distanceGeometryMenuItem.setText("Distance Geometry");
        distanceGeometryMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                distanceGeometryMenuItemActionPerformed(evt);
            }
        });
        layoutMenu.add(distanceGeometryMenuItem);

        jMenuBar1.add(layoutMenu);

        clusteringMenu.setForeground(new java.awt.Color(255, 255, 255));
        clusteringMenu.setText("Clustering");

        kmeansMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_K, java.awt.event.InputEvent.CTRL_MASK));
        kmeansMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Flag-Cyan.gif"))); // NOI18N
        kmeansMenuItem.setText("K-Means");
        kmeansMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kmeansMenuItemActionPerformed(evt);
            }
        });
        clusteringMenu.add(kmeansMenuItem);

        affinityMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.CTRL_MASK));
        affinityMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Flag-Red.gif"))); // NOI18N
        affinityMenuItem.setText("Affinity Propagation");
        affinityMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                affinityMenuItemActionPerformed(evt);
            }
        });
        clusteringMenu.add(affinityMenuItem);

        mclMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_M, java.awt.event.InputEvent.CTRL_MASK));
        mclMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Flag-Yellow.gif"))); // NOI18N
        mclMenuItem.setText("Markov Clustering");
        mclMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mclMenuItemActionPerformed(evt);
            }
        });
        clusteringMenu.add(mclMenuItem);

        jMenuItem2.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.CTRL_MASK));
        jMenuItem2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Flag-Green.gif"))); // NOI18N
        jMenuItem2.setText("Predefined Clustering");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        clusteringMenu.add(jMenuItem2);

        jMenuBar1.add(clusteringMenu);

        zoomMenu.setForeground(new java.awt.Color(255, 255, 255));
        zoomMenu.setText("Zoom");

        jMenuItem1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Blue/Zoom In.gif"))); // NOI18N
        zoomMenu.add(jMenuItem1);

        jMenuBar1.add(zoomMenu);

        selectMenu.setForeground(new java.awt.Color(255, 255, 255));
        selectMenu.setText("Select");

        selectAllMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.ALT_MASK));
        selectAllMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Doc-Ok.gif"))); // NOI18N
        selectAllMenuItem.setText("All");
        selectAllMenuItem.setToolTipText("Select all nodes");
        selectAllMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectAllMenuItemActionPerformed(evt);
            }
        });
        selectMenu.add(selectAllMenuItem);

        selectNoneMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Q, java.awt.event.InputEvent.ALT_MASK));
        selectNoneMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Doc-Error.gif"))); // NOI18N
        selectNoneMenuItem.setText("None");
        selectNoneMenuItem.setToolTipText("Clear selection");
        selectNoneMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectNoneMenuItemActionPerformed(evt);
            }
        });
        selectMenu.add(selectNoneMenuItem);

        selectNodeLabelByRegExpMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_F, java.awt.event.InputEvent.ALT_MASK));
        selectNodeLabelByRegExpMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Search.gif"))); // NOI18N
        selectNodeLabelByRegExpMenuItem.setText("By label");
        selectNodeLabelByRegExpMenuItem.setToolTipText("Select nodes by label using regular expressions.");
        selectNodeLabelByRegExpMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectNodeLabelByRegExpMenuItemActionPerformed(evt);
            }
        });
        selectMenu.add(selectNodeLabelByRegExpMenuItem);

        selectNodeAnnotationByRegExpMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_N, java.awt.event.InputEvent.ALT_MASK));
        selectNodeAnnotationByRegExpMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Blue/Search.gif"))); // NOI18N
        selectNodeAnnotationByRegExpMenuItem.setText("By annotation");
        selectNodeAnnotationByRegExpMenuItem.setToolTipText("Select nodes by annotation using regular expressions.");
        selectNodeAnnotationByRegExpMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectNodeAnnotationByRegExpMenuItemActionPerformed(evt);
            }
        });
        selectMenu.add(selectNodeAnnotationByRegExpMenuItem);

        invertFixMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Orange/Char - Tilde.gif"))); // NOI18N
        invertFixMenuItem.setText("Invert");
        invertFixMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                invertFixMenuItemActionPerformed(evt);
            }
        });
        selectMenu.add(invertFixMenuItem);

        selectGrowMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/16x16/Direction Diag1.gif"))); // NOI18N
        selectGrowMenuItem.setText("Grow selection");
        selectGrowMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectGrowMenuItemActionPerformed(evt);
            }
        });
        selectMenu.add(selectGrowMenuItem);

        jMenuBar1.add(selectMenu);

        optionMenu.setForeground(new java.awt.Color(255, 255, 255));
        optionMenu.setText("Options");

        jMenuItem3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Chart2.gif"))); // NOI18N
        jMenuItem3.setText("Network characteristics");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        optionMenu.add(jMenuItem3);

        changeNodeSizeMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/16x16/Directions.gif"))); // NOI18N
        changeNodeSizeMenuItem.setText("Change node size");
        changeNodeSizeMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                changeNodeSizeMenuItemActionPerformed(evt);
            }
        });
        optionMenu.add(changeNodeSizeMenuItem);

        setEdgeLenMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/16x16/Size Horz.gif"))); // NOI18N
        setEdgeLenMenuItem.setText("Edge length");
        setEdgeLenMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setEdgeLenMenuItemActionPerformed(evt);
            }
        });
        optionMenu.add(setEdgeLenMenuItem);
        optionMenu.add(jSeparator2);

        colorMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Chart1-Edit.gif"))); // NOI18N
        colorMenu.setText("Color");
        colorMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                colorMenuActionPerformed(evt);
            }
        });

        changeColorMenuItem.setText("Change node color");
        changeColorMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                changeColorMenuItemActionPerformed(evt);
            }
        });
        colorMenu.add(changeColorMenuItem);

        switchColorMenuItem.setText("Switch channels");
        switchColorMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                switchColorMenuItemActionPerformed(evt);
            }
        });
        colorMenu.add(switchColorMenuItem);

        copyColorMenuItem.setText("Copy channels");
        copyColorMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                copyColorMenuItemActionPerformed(evt);
            }
        });
        colorMenu.add(copyColorMenuItem);
        colorMenu.add(jSeparator4);

        setBasicEdgeColorMenuItem.setText("Base color");
        setBasicEdgeColorMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setBasicEdgeColorMenuItemActionPerformed(evt);
            }
        });
        colorMenu.add(setBasicEdgeColorMenuItem);

        setBackgroundColorMenuItem.setText("Background");
        setBackgroundColorMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setBackgroundColorMenuItemActionPerformed(evt);
            }
        });
        colorMenu.add(setBackgroundColorMenuItem);

        optionMenu.add(colorMenu);

        fontMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Orange/Text2.gif"))); // NOI18N
        fontMenu.setText("Font");

        setLabelColorMenuItem.setText("Label");
        setLabelColorMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                setLabelColorMenuItemActionPerformed(evt);
            }
        });
        fontMenu.add(setLabelColorMenuItem);

        changeFontSizeMenuItem.setText("Font size");
        changeFontSizeMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                changeFontSizeMenuItemActionPerformed(evt);
            }
        });
        fontMenu.add(changeFontSizeMenuItem);

        optionMenu.add(fontMenu);

        jMenuBar1.add(optionMenu);

        manipulateMenu.setForeground(new java.awt.Color(255, 255, 255));
        manipulateMenu.setText("Manipulate");

        cropMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Cut.gif"))); // NOI18N
        cropMenuItem.setText("Crop graph");
        cropMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cropMenuItemActionPerformed(evt);
            }
        });
        manipulateMenu.add(cropMenuItem);

        rotateMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Orange/Rotate.gif"))); // NOI18N
        rotateMenu.setText("Rotate");

        rotateRightMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Green/Action Redo.gif"))); // NOI18N
        rotateRightMenuItem.setText("90d clockwise");
        rotateRightMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rotateRightMenuItemActionPerformed(evt);
            }
        });
        rotateMenu.add(rotateRightMenuItem);

        rotateLeftMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Green/Action Undo.gif"))); // NOI18N
        rotateLeftMenuItem.setText("90d anti-clockwise");
        rotateLeftMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rotateLeftMenuItemActionPerformed(evt);
            }
        });
        rotateMenu.add(rotateLeftMenuItem);

        manipulateMenu.add(rotateMenu);

        flipMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Orange/Refresh.gif"))); // NOI18N
        flipMenu.setText("Flip");

        flipXItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Blue/Back Top.gif"))); // NOI18N
        flipXItem.setText("Vertical");
        flipMenu.add(flipXItem);

        flipYItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Blue/Back.gif"))); // NOI18N
        flipYItem.setText("Horizontal");
        flipMenu.add(flipYItem);

        manipulateMenu.add(flipMenu);

        alignNodesMenu.setText("Align nodes");

        alignTop.setText("Horizontally based on top node");
        alignTop.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                alignTopActionPerformed(evt);
            }
        });
        alignNodesMenu.add(alignTop);

        alignBottom.setText("Horizontally based on bottom node");
        alignBottom.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                alignBottomActionPerformed(evt);
            }
        });
        alignNodesMenu.add(alignBottom);

        alignLeft.setText("Vertically based on left-most node");
        alignLeft.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                alignLeftActionPerformed(evt);
            }
        });
        alignNodesMenu.add(alignLeft);

        alignRight.setText("Vertically based on right-most node");
        alignRight.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                alignRightActionPerformed(evt);
            }
        });
        alignNodesMenu.add(alignRight);

        manipulateMenu.add(alignNodesMenu);
        manipulateMenu.add(jSeparator5);

        recalcButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Blue/Calc.gif"))); // NOI18N
        recalcButton.setText("Recalculate");
        recalcButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                recalcButtonActionPerformed(evt);
            }
        });
        manipulateMenu.add(recalcButton);

        jMenuBar1.add(manipulateMenu);

        displayMenu.setForeground(new java.awt.Color(255, 255, 255));
        displayMenu.setText("Display");

        prettyCBMItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_I, ActionEvent.ALT_MASK));
        prettyCBMItem.setText("Interactions");
        prettyCBMItem.setToolTipText("<html>\nIf enabled, interactions will be presented as<br/>\ncurves and colors. If disabled, simple straight<br/>\nedges will be used.\n</html>");
        prettyCBMItem.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                prettyCBMItemItemStateChanged(evt);
            }
        });
        prettyCBMItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                prettyCBMItemActionPerformed(evt);
            }
        });
        displayMenu.add(prettyCBMItem);

        namesCBMItem.setSelected(true);
        namesCBMItem.setText("Labels");
        namesCBMItem.setToolTipText("Check this to display node labels or annotations");
        namesCBMItem.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                namesCBMItemItemStateChanged(evt);
            }
        });
        displayMenu.add(namesCBMItem);

        showNamesCBMItem.setSelected(true);
        showNamesCBMItem.setText("Show names");
        showNamesCBMItem.setToolTipText("If checked, the node label will be displayed. Otherwise, the node annotation will be shown.");
        showNamesCBMItem.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                showNamesCBMItemItemStateChanged(evt);
            }
        });
        displayMenu.add(showNamesCBMItem);

        directedCBMItem.setText("Directed");
        directedCBMItem.setToolTipText("Check this to diplay arrows, signifying a directionality of an edge.");
        directedCBMItem.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                directedCBMItemItemStateChanged(evt);
            }
        });
        displayMenu.add(directedCBMItem);

        confidenceCBMItem.setSelected(true);
        confidenceCBMItem.setText("Confidence");
        confidenceCBMItem.setToolTipText("Display confidence or draw all edges as solid lines.");
        confidenceCBMItem.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                confidenceCBMItemItemStateChanged(evt);
            }
        });
        displayMenu.add(confidenceCBMItem);

        alphaCBMItem.setSelected(true);
        alphaCBMItem.setText("Show alpha");
        alphaCBMItem.setToolTipText("Check this to show confidences as alpha opacity. Uncheck to display as dashed lines.");
        alphaCBMItem.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                alphaCBMItemItemStateChanged(evt);
            }
        });
        displayMenu.add(alphaCBMItem);
        displayMenu.add(jSeparator7);

        hideWhenMoveCBMItem.setSelected(true);
        hideWhenMoveCBMItem.setText("Hide edges on move");
        hideWhenMoveCBMItem.setToolTipText("Check to hide all other edges when moving a node. Very useful for large graphs.");
        hideWhenMoveCBMItem.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                hideWhenMoveCBMItemItemStateChanged(evt);
            }
        });
        displayMenu.add(hideWhenMoveCBMItem);
        displayMenu.add(jSeparator8);

        nodeColorDisplayMenu.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Chart1.gif"))); // NOI18N
        nodeColorDisplayMenu.setText("Node color set");

        ButtonGroup nodeColorSetGroup = new ButtonGroup();
        nodeColorSetGroup.add(channel1MenuItem);
        nodeColorSetGroup.add(channel2MenuItem);
        nodeColorSetGroup.add(channel3MenuItem);
        nodeColorSetGroup.add(jRadioButtonMenuItem1);
        channel1MenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_1, java.awt.event.InputEvent.CTRL_MASK));
        channel1MenuItem.setSelected(true);
        channel1MenuItem.setText("1");
        channel1MenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                channel1MenuItemActionPerformed(evt);
            }
        });
        nodeColorDisplayMenu.add(channel1MenuItem);

        channel2MenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_2, java.awt.event.InputEvent.CTRL_MASK));
        channel2MenuItem.setText("2");
        channel2MenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                channel2MenuItemActionPerformed(evt);
            }
        });
        nodeColorDisplayMenu.add(channel2MenuItem);

        channel3MenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_3, java.awt.event.InputEvent.CTRL_MASK));
        channel3MenuItem.setText("3");
        channel3MenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                channel3MenuItemActionPerformed(evt);
            }
        });
        nodeColorDisplayMenu.add(channel3MenuItem);

        jRadioButtonMenuItem1.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_4, java.awt.event.InputEvent.CTRL_MASK));
        jRadioButtonMenuItem1.setText("Clustering Color");
        jRadioButtonMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButtonMenuItem1ActionPerformed(evt);
            }
        });
        nodeColorDisplayMenu.add(jRadioButtonMenuItem1);

        displayMenu.add(nodeColorDisplayMenu);

        jMenuBar1.add(displayMenu);

        helpMenu.setForeground(new java.awt.Color(255, 255, 255));
        helpMenu.setText("Help");

        aboutMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medusa/images/Info.gif"))); // NOI18N
        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });
        helpMenu.add(aboutMenuItem);

        jMenuBar1.add(helpMenu);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void saveMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveMenuItemActionPerformed
		saveEvent();
    }//GEN-LAST:event_saveMenuItemActionPerformed

    private void exportJPGMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportJPGMenuItemActionPerformed
		exportImageEvent(false);
    }//GEN-LAST:event_exportJPGMenuItemActionPerformed

    private void exportPNGMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportPNGMenuItemActionPerformed
		exportImageEvent(true);
    }//GEN-LAST:event_exportPNGMenuItemActionPerformed

    private void quitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitMenuItemActionPerformed
		quitApplication();
    }//GEN-LAST:event_quitMenuItemActionPerformed

    private void randomMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_randomMenuItemActionPerformed
		System.out.println("RANDOM");
		stopRelax();
		// Layouts layout = new Layouts();
		Graph g = stringletPanel.getGraph();
		Layouts.Apply_Random_Coordinates(g, stringletPanel);
		updateInfo();
		stringletPanel.repaint();
    }//GEN-LAST:event_randomMenuItemActionPerformed

    private void circularMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_circularMenuItemActionPerformed
		System.out.println("CIRCULAR");
		stopRelax();
		Graph g = stringletPanel.getGraph();
		Layouts.Apply_Circular_Coordinates(g, stringletPanel);
		updateInfo();
		stringletPanel.repaint();
    }//GEN-LAST:event_circularMenuItemActionPerformed

    private void gridMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_gridMenuItemActionPerformed
		System.out.println("GRID");
		stopRelax();
		Graph g = stringletPanel.getGraph();
		Layouts.Apply_Grid_Coordinates(g, stringletPanel);
		updateInfo();
		stringletPanel.repaint();
    }//GEN-LAST:event_gridMenuItemActionPerformed

    private void fruchtermanMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fruchtermanMenuItemActionPerformed
		Graph g = stringletPanel.getGraph();
		if (g.getNodeSize() > 1) {
			System.out.println("FRUCHTERMAN");
			stopRelax();
			stringletPanel.energy();
			updateInfo();
			stringletPanel.repaint();
		}
    }//GEN-LAST:event_fruchtermanMenuItemActionPerformed

    private void hierarchicalMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_hierarchicalMenuItemActionPerformed
		System.out.println("HIERARCHICAL");
		stopRelax();
		Graph g = stringletPanel.getGraph();
		Layouts.Apply_GO_like_Coordinates(g, stringletPanel);
		updateInfo();
		stringletPanel.repaint();
    }//GEN-LAST:event_hierarchicalMenuItemActionPerformed

    private void distanceGeometryMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_distanceGeometryMenuItemActionPerformed
		System.out.println("DISTANCE GEOMETRY");
		stopRelax();
		Graph g = stringletPanel.getGraph();
		Layouts.Apply_Distance_Geomretry_Coordinates(g, stringletPanel);
		updateInfo();
		stringletPanel.repaint();
    }//GEN-LAST:event_distanceGeometryMenuItemActionPerformed

    private void kmeansMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kmeansMenuItemActionPerformed
		stopRelax();
		System.out.println("K-Means");
		Graph g = stringletPanel.getGraph();
		Layouts.Apply_Kmeans_Clustering(g, stringletPanel);
		updateInfo();
		stringletPanel.repaint();
    }//GEN-LAST:event_kmeansMenuItemActionPerformed

    private void affinityMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_affinityMenuItemActionPerformed
		stopRelax();
		System.out.println("AFFINITY");
		Graph g = stringletPanel.getGraph();
		Layouts.Apply_Affinity_Propagation_Clustering(g, stringletPanel);
		updateInfo();
		stringletPanel.repaint();
    }//GEN-LAST:event_affinityMenuItemActionPerformed

    private void mclMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mclMenuItemActionPerformed
		stopRelax();
		System.out.println("MCL");
		Graph g = stringletPanel.getGraph();
		Layouts.Apply_MCL_Propagation_Clustering(g, stringletPanel);
		updateInfo();
		stringletPanel.repaint();
    }//GEN-LAST:event_mclMenuItemActionPerformed

    private void selectAllMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectAllMenuItemActionPerformed
		stringletPanel.setFix(true);
    }//GEN-LAST:event_selectAllMenuItemActionPerformed

    private void selectNoneMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectNoneMenuItemActionPerformed
		stringletPanel.setFix(false);
    }//GEN-LAST:event_selectNoneMenuItemActionPerformed

    private void selectNodeLabelByRegExpMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectNodeLabelByRegExpMenuItemActionPerformed
		searchNodeEvent(true);
    }//GEN-LAST:event_selectNodeLabelByRegExpMenuItemActionPerformed

    private void selectNodeAnnotationByRegExpMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectNodeAnnotationByRegExpMenuItemActionPerformed
		searchNodeEvent(false);
    }//GEN-LAST:event_selectNodeAnnotationByRegExpMenuItemActionPerformed

    private void invertFixMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_invertFixMenuItemActionPerformed
		stringletPanel.invertFix();
    }//GEN-LAST:event_invertFixMenuItemActionPerformed

    private void selectGrowMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectGrowMenuItemActionPerformed
		stringletPanel.growSelection();
    }//GEN-LAST:event_selectGrowMenuItemActionPerformed

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed

		String aboutText = "<html><center><h2>Medusa 1.5</h2><br>" +
				"<center>Edited by Andreas Schlicker<br>MPII 2009<br><br>based on Medusa from:<br><br>Authors:<br>Sean Hooper<br>Georgios Pavlopoulos" +
				"<p><p>EMBL Heidelberg 2008</center>" +
				"<p><center><b>hooper@embl.de<br>pavlopou@embl.de<br></b>" + "<br>Full documentation at<p>www.bork.embl.de/medusa</center></html>";

		JOptionPane.showMessageDialog(this, aboutText);
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void changeNodeSizeMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_changeNodeSizeMenuItemActionPerformed
		changeNodeSizeEvent();
    }//GEN-LAST:event_changeNodeSizeMenuItemActionPerformed

    private void setEdgeLenMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setEdgeLenMenuItemActionPerformed
		setEdgeLenEvent();
    }//GEN-LAST:event_setEdgeLenMenuItemActionPerformed

    private void changeColorMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_changeColorMenuItemActionPerformed
		changeColorEvent();
    }//GEN-LAST:event_changeColorMenuItemActionPerformed

    private void switchColorMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_switchColorMenuItemActionPerformed
		switchColorEvent();
    }//GEN-LAST:event_switchColorMenuItemActionPerformed

    private void copyColorMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_copyColorMenuItemActionPerformed
		copyColorEvent();
    }//GEN-LAST:event_copyColorMenuItemActionPerformed

    private void setBasicEdgeColorMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setBasicEdgeColorMenuItemActionPerformed
		setBasicEdgeColorEvent();
    }//GEN-LAST:event_setBasicEdgeColorMenuItemActionPerformed

    private void setBackgroundColorMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setBackgroundColorMenuItemActionPerformed
		setBackgroundColorEvent();
    }//GEN-LAST:event_setBackgroundColorMenuItemActionPerformed

    private void setLabelColorMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_setLabelColorMenuItemActionPerformed
		setLabelColorEvent();
    }//GEN-LAST:event_setLabelColorMenuItemActionPerformed

    private void changeFontSizeMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_changeFontSizeMenuItemActionPerformed
		changeFontSizeEvent();
    }//GEN-LAST:event_changeFontSizeMenuItemActionPerformed

    private void colorMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_colorMenuActionPerformed
		// TODO add your handling code here:
    }//GEN-LAST:event_colorMenuActionPerformed

    private void cropMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cropMenuItemActionPerformed
		String confidence = (String) JOptionPane.showInputDialog("Choose minimum confidence level:" + "",
				"1.0");
		if (confidence != null) {
			stringletPanel.crop(Double.parseDouble(confidence));
			updateInfo();
			stringletPanel.repaint();
		}
    }//GEN-LAST:event_cropMenuItemActionPerformed

    private void rotateRightMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rotateRightMenuItemActionPerformed
		rotateEvent(Math.PI / 2);
    }//GEN-LAST:event_rotateRightMenuItemActionPerformed

    private void rotateLeftMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rotateLeftMenuItemActionPerformed
		rotateEvent(-Math.PI / 2);
    }//GEN-LAST:event_rotateLeftMenuItemActionPerformed

    private void prettyCBMItemItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_prettyCBMItemItemStateChanged
		stringletPanel.setPretty(prettyCBMItem.isSelected());
//        if(prettyCBMItem.isSelected()==true)hideInteractions = true;
//        if(prettyCBMItem.isSelected()==false)hideInteractions = false;
		stringletPanel.repaint();
		validate();
    }//GEN-LAST:event_prettyCBMItemItemStateChanged
	private void hideShowInteractionsEvent() {
		Container content = getContentPane();
		if (!hideInteractions) {
			hideInteractions = true;
		} else {
			hideInteractions = false;
		}
		validate();

	}
    private void namesCBMItemItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_namesCBMItemItemStateChanged
		stringletPanel.setLabel(namesCBMItem.isSelected());
		stringletPanel.repaint();
    }//GEN-LAST:event_namesCBMItemItemStateChanged

    private void showNamesCBMItemItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_showNamesCBMItemItemStateChanged
		stringletPanel.setShowName(showNamesCBMItem.isSelected());
		stringletPanel.repaint();
    }//GEN-LAST:event_showNamesCBMItemItemStateChanged

    private void confidenceCBMItemItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_confidenceCBMItemItemStateChanged
		stringletPanel.setConfidence(confidenceCBMItem.isSelected());
		stringletPanel.repaint();
    }//GEN-LAST:event_confidenceCBMItemItemStateChanged

    private void directedCBMItemItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_directedCBMItemItemStateChanged
		stringletPanel.setArrows(directedCBMItem.isSelected());
		stringletPanel.repaint();
    }//GEN-LAST:event_directedCBMItemItemStateChanged

    private void hideWhenMoveCBMItemItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_hideWhenMoveCBMItemItemStateChanged
		stringletPanel.setHideWhenMove(hideWhenMoveCBMItem.isSelected());
		stringletPanel.repaint();
    }//GEN-LAST:event_hideWhenMoveCBMItemItemStateChanged

    private void alphaCBMItemItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_alphaCBMItemItemStateChanged
		stringletPanel.setAlpha(alphaCBMItem.isSelected());
		stringletPanel.repaint();
    }//GEN-LAST:event_alphaCBMItemItemStateChanged

    private void channel1MenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_channel1MenuItemActionPerformed
		setNodeColorSet(1);
    }//GEN-LAST:event_channel1MenuItemActionPerformed

    private void channel2MenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_channel2MenuItemActionPerformed
		setNodeColorSet(2);
    }//GEN-LAST:event_channel2MenuItemActionPerformed

    private void channel3MenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_channel3MenuItemActionPerformed
		setNodeColorSet(3);
    }//GEN-LAST:event_channel3MenuItemActionPerformed

    private void recalcButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_recalcButtonActionPerformed
		recalcEvent();
    }//GEN-LAST:event_recalcButtonActionPerformed

    private void startRelaxMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startRelaxMenuItemActionPerformed
		stringletPanel.start();
}//GEN-LAST:event_startRelaxMenuItemActionPerformed

    private void stopRelaxMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stopRelaxMenuItemActionPerformed
		stringletPanel.stop();
}//GEN-LAST:event_stopRelaxMenuItemActionPerformed

    private void temperatureButtonItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_temperatureButtonItemStateChanged
		stringletPanel.setCool(temperatureButton.isSelected());
}//GEN-LAST:event_temperatureButtonItemStateChanged

    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
		String[] result = stringletPanel.getGraphData();
		String planar = "Graph is " + ((stringletPanel.getGraph().isPlanar()) ? "" : "not ") + "planar";

		String display = "<html><b>nodes: " +
				result[0] + "<br>edges: " + result[1] +
				"<br>File: " + lastFile + "</b></html>";
		JOptionPane.showMessageDialog(null, display);
    }//GEN-LAST:event_jMenuItem3ActionPerformed

    private void exportEPSMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportEPSMenuItemActionPerformed
		exportEPSEvent();
    }//GEN-LAST:event_exportEPSMenuItemActionPerformed

    private void exportPSMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportPSMenuItemActionPerformed
		exportPSEvent();
    }//GEN-LAST:event_exportPSMenuItemActionPerformed

    private void jRadioButtonMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButtonMenuItem1ActionPerformed
		setNodeColorSet(4);
    }//GEN-LAST:event_jRadioButtonMenuItem1ActionPerformed

private void formKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyTyped
// TODO add your handling code here:
	if (evt.getKeyChar() == 'r') {
		if (stringletPanel.running) {
			stringletPanel.stop();
		} else {
			stringletPanel.start();
		}
	}

}//GEN-LAST:event_formKeyTyped

private void prettyCBMItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prettyCBMItemActionPerformed
	// TODO add your handling code here:
}//GEN-LAST:event_prettyCBMItemActionPerformed

private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
	stopRelax();
	System.out.println("Predefined");
	Graph g = stringletPanel.getGraph();
	Layouts.Apply_Predefined_Clustering(g, stringletPanel);
	updateInfo();
	stringletPanel.repaint();
}//GEN-LAST:event_jMenuItem2ActionPerformed

private void jMenuItem7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem7ActionPerformed
	exportCytoscapeEvent();
}//GEN-LAST:event_jMenuItem7ActionPerformed

private void jMenuItem8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem8ActionPerformed
	exportGraphVizEvent();
}//GEN-LAST:event_jMenuItem8ActionPerformed

private void alignTopActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_alignTopActionPerformed
// TODO add your handling code here:
	alignNodes(EditableGraphPanel.EXTREME_TOP);
}//GEN-LAST:event_alignTopActionPerformed

private void alignBottomActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_alignBottomActionPerformed
// TODO add your handling code here:
	alignNodes(EditableGraphPanel.EXTREME_BOTTOM);
}//GEN-LAST:event_alignBottomActionPerformed

private void alignLeftActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_alignLeftActionPerformed
// TODO add your handling code here:
	alignNodes(EditableGraphPanel.EXTREME_LEFT);
}//GEN-LAST:event_alignLeftActionPerformed

private void alignRightActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_alignRightActionPerformed
// TODO add your handling code here:
	alignNodes(EditableGraphPanel.EXTREME_RIGHT);
}//GEN-LAST:event_alignRightActionPerformed
	//---------------------------------------------------------------------------------------------------

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) throws IOException {
		final String fileName = args[0];
		java.awt.EventQueue.invokeLater(new Runnable() {

			public void run() {
				MedusaSimplerFrame frame = new MedusaSimplerFrame();
				frame.setVisible(true);
				try {
					frame.waitForLoad(fileName, DataLoader.LOAD_MEDUSA);
				} catch (IOException ie) {
					ie.printStackTrace();
					JOptionPane.showMessageDialog(frame, "The file could not be found or opened",
							"Load Error", JOptionPane.ERROR_MESSAGE);
				} catch (DataFormatException dfe) {
					JOptionPane.showMessageDialog(frame, dfe.getMessage(),
							"Data Error", JOptionPane.ERROR_MESSAGE);
				}
			}
		});
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JMenuItem affinityMenuItem;
    private javax.swing.JMenuItem alignBottom;
    private javax.swing.JMenuItem alignLeft;
    private javax.swing.JMenu alignNodesMenu;
    private javax.swing.JMenuItem alignRight;
    private javax.swing.JMenuItem alignTop;
    private javax.swing.JCheckBoxMenuItem alphaCBMItem;
    private javax.swing.JMenuItem changeColorMenuItem;
    private javax.swing.JMenuItem changeFontSizeMenuItem;
    private javax.swing.JMenuItem changeNodeSizeMenuItem;
    public static javax.swing.JRadioButtonMenuItem channel1MenuItem;
    public static javax.swing.JRadioButtonMenuItem channel2MenuItem;
    public static javax.swing.JRadioButtonMenuItem channel3MenuItem;
    private javax.swing.JMenuItem circularMenuItem;
    private javax.swing.JMenu clusteringMenu;
    private javax.swing.JMenu colorMenu;
    private javax.swing.JCheckBoxMenuItem confidenceCBMItem;
    private javax.swing.JMenuItem copyColorMenuItem;
    private javax.swing.JMenuItem cropMenuItem;
    private javax.swing.JCheckBoxMenuItem directedCBMItem;
    private javax.swing.JMenu displayMenu;
    private javax.swing.JMenuItem distanceGeometryMenuItem;
    private javax.swing.JMenuItem exportEPSMenuItem;
    private javax.swing.JMenu exportImageMenu;
    private javax.swing.JMenuItem exportJPGMenuItem;
    private javax.swing.JMenu exportMenu;
    private javax.swing.JMenuItem exportPNGMenuItem;
    private javax.swing.JMenuItem exportPSMenuItem;
    private javax.swing.JMenu exportPostscriptMenu;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenu flipMenu;
    private javax.swing.JMenuItem flipXItem;
    private javax.swing.JMenuItem flipYItem;
    private javax.swing.JMenu fontMenu;
    private javax.swing.JMenuItem fruchtermanMenuItem;
    private javax.swing.JMenuItem gridMenuItem;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JCheckBoxMenuItem hideWhenMoveCBMItem;
    private javax.swing.JMenuItem hierarchicalMenuItem;
    private javax.swing.JMenuItem invertFixMenuItem;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem7;
    private javax.swing.JMenuItem jMenuItem8;
    public static javax.swing.JRadioButtonMenuItem jRadioButtonMenuItem1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator10;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSeparator jSeparator4;
    private javax.swing.JSeparator jSeparator5;
    private javax.swing.JSeparator jSeparator7;
    private javax.swing.JSeparator jSeparator8;
    private javax.swing.JSeparator jSeparator9;
    private javax.swing.JMenuItem kmeansMenuItem;
    private javax.swing.JMenu layoutMenu;
    private javax.swing.JMenu manipulateMenu;
    private javax.swing.JMenuItem mclMenuItem;
    private javax.swing.JCheckBoxMenuItem namesCBMItem;
    private javax.swing.JMenu nodeColorDisplayMenu;
    private javax.swing.JMenu optionMenu;
    private javax.swing.JCheckBoxMenuItem prettyCBMItem;
    private javax.swing.JMenuItem quitMenuItem;
    private javax.swing.JMenuItem randomMenuItem;
    private javax.swing.JMenuItem recalcButton;
    private javax.swing.JMenu relaxMenu;
    private javax.swing.JMenuItem rotateLeftMenuItem;
    private javax.swing.JMenu rotateMenu;
    private javax.swing.JMenuItem rotateRightMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JMenuItem selectAllMenuItem;
    private javax.swing.JMenuItem selectGrowMenuItem;
    private javax.swing.JMenu selectMenu;
    private javax.swing.JMenuItem selectNodeAnnotationByRegExpMenuItem;
    private javax.swing.JMenuItem selectNodeLabelByRegExpMenuItem;
    private javax.swing.JMenuItem selectNoneMenuItem;
    private javax.swing.JMenuItem setBackgroundColorMenuItem;
    private javax.swing.JMenuItem setBasicEdgeColorMenuItem;
    private javax.swing.JMenuItem setEdgeLenMenuItem;
    private javax.swing.JMenuItem setLabelColorMenuItem;
    private javax.swing.JCheckBoxMenuItem showNamesCBMItem;
    private javax.swing.JMenuItem startRelaxMenuItem;
    private javax.swing.JMenuItem stopRelaxMenuItem;
    private javax.swing.JMenuItem switchColorMenuItem;
    private javax.swing.JCheckBoxMenuItem temperatureButton;
    private javax.swing.JMenu zoomMenu;
    // End of variables declaration//GEN-END:variables
}
