package medusa.georgios.ClusteringAlgorithms;
import java.awt.Graphics;

// Neighbour clusters or trees, built by the neighbour joining algorithm

class NJCluster {
  int lab;			// Cluster identifier
  int card;			// The number of sequences in the cluster
  NJCluster left, right;	// Left and right children, or null
  float dleft, dright;		// Length of edges to the children, if any
  float[] dmat;		// Distances to lower-numbered nodes, or null

  public NJCluster(int lab, float[] dmat) {	// Leaves = single sequences
    this.lab = lab + 1; 
    card = 1;
    this.dmat = dmat;
  }

  public NJCluster(int lab, NJCluster left, float dleft, 
		   NJCluster right, float dright, float[] dmat) { 
    this.lab = lab + 1; 
    this.left = left;   this.dleft  = dleft;
    this.right = right; this.dright = dright;
    card = left.card + right.card;
    this.dmat = dmat;
  }

  public boolean live()
  { return dmat != null; }

  public void kill() 
  { dmat = null; }



}
