package medusa.georgios.ClusteringAlgorithms;

// The UPGMA algorithm

public class UPGMA {
  int K;			// The number of clusters created so far
  UPCluster[] cluster;		// The nodes (clusters) of the resulting tree
  public StringBuffer NHX = new StringBuffer("");
  public UPGMA(float[][] ds) {
    int N = ds.length;
    cluster = new UPCluster[2*N-1];
    for (int i=0; i<N; i++) 
      cluster[i] = new UPCluster(i, ds[i]);
    K = N;
    while (K < 2*N-1)
      findAndJoin();
  }

  public UPCluster getRoot()
  { return cluster[K-1]; }
  
  public float d(int i, int j) 
  { return cluster[Math.max(i, j)].dmat[Math.min(i, j)]; }

  void findAndJoin() { // Find closest two live clusters and join them
    int mini = -1, minj = -1;
    float mind = Float.POSITIVE_INFINITY;
    for (int i=0; i<K; i++) 
      if (cluster[i].live())
	for (int j=0; j<i; j++) 
	  if (cluster[j].live()) {
	    float d = d(i, j);
	    if (d < mind) {
	      mind = d;
	      mini = i;
	      minj = j;
	    }
	  }
    join(mini, minj);
  }

  public void join(int i, int j) { // Join i and j to form node K
    // System.out.println("Joining " + (i+1) + " and " + (j+1) + " to form " 
    //	       + (K+1) + " at height " + (int)(d(i, j) * 50)/100.0);
    float[] dmat = new float[K];
    for (int m=0; m<K; m++)
      if (cluster[m].live() && m != i && m != j) 
	dmat[m] = (d(i, m) * cluster[i].card + d(j, m) * cluster[j].card)
	          / (cluster[i].card + cluster[j].card);
    cluster[K] = new UPCluster(K, cluster[i], cluster[j], d(i, j) / 2, dmat);
    cluster[i].kill(); 
    cluster[j].kill();
    K++;
  }
  
  
     public boolean is_internal(UPCluster cluster)
    {
        if( cluster.left == null &&  cluster.right == null)
            return false;
        else
            return true;              
    }
  
   public String NewickFormat(UPCluster cluster) {
       if(this.is_internal(cluster)){
            NHX.append("(");
            this.NewickFormat(cluster.left);}
        
         if(this.is_internal(cluster)){NHX.append(",");}
        else
        {NHX.append(Clustering_NJ_UPGMA.labels.get(cluster.lab-1));}
        if(this.is_internal(cluster)){
            this.NewickFormat(cluster.right);
        NHX.append(")");
        } 
       return NHX.toString()+";";
  }
   
}

